//+------------------------------------------------------------------+
//|                                            Cronex StochR% SP.mq4 |
//|                                        Copyright  2007, Cronex. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
// mod Sto Rsi spos
#property  copyright "Copyright  2007, Cronex"
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 6
#property  indicator_color1  Magenta
#property  indicator_color2  DarkOrange
#property  indicator_color3  SlateGray
#property  indicator_color4  OrangeRed
#property  indicator_color5  CornflowerBlue
#property  indicator_color6  SteelBlue
#property  indicator_level1 -0.20
#property  indicator_level2  0.20
#property  indicator_level3  0.50
#property  indicator_level4  0.80
#property  indicator_levelcolor LightSlateGray
#property  indicator_width4  2
#property  indicator_width5  2

//---- indicator parameters
extern int RSI=14;
extern int RSIprice=0;

extern int StochK=8;
extern int StochD=5;
extern int StochSl=3;
extern int StochMAmode=1;
extern int StochPriceField=0;

extern int SPFastMA=10;
extern int SPSlowMA=10;
extern int SPSigMA =5;
extern int SPMAmode=3;    //price close only(onAraay)

extern string   notes___Price = "0C 1O 2H 3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";
extern string   StoPriceField = "0 Low/High  1 Cl/Cl";
extern string   ______MA_Mode = "SMA0 EMA1 SMMA2 LWMA3";


//---- indicator buffers
double     RSIBuffer[];
double     StochBuffer[];
double     SPBuffer[];
double     FastMABuffer[];
double     SlowMABuffer[];
double     TmpDiverBuff[];
double     DiverBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(7);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);   
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexDrawBegin(1,SPSlowMA);
//   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,RSIBuffer);
   SetIndexBuffer(1,StochBuffer);
   SetIndexBuffer(2,SPBuffer);
   SetIndexBuffer(3,FastMABuffer);
   SetIndexBuffer(4,SlowMABuffer);
   SetIndexBuffer(5,DiverBuffer);
   SetIndexBuffer(6,TmpDiverBuff);
//---- name for DataWindow and indicator subwindow label
   SetIndexLabel(0,"RSI");
   SetIndexLabel(1,"Stoch");
   SetIndexLabel(2,"RSI Stoch SuperPosition");
   SetIndexLabel(3,"SP_Fast MA");
   SetIndexLabel(4,"SP_Slow MA");
   SetIndexLabel(5,"Sto-RSI Diver SigMA("+SPSigMA+")");
//   SetIndexShift(3,-2);

IndicatorShortName("RSI ("+RSI+") Stoch ("+StochK+","+StochD+","+StochSl+") SuperPosition ");

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Cronex R5                                                        |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars<0) return(-1);

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- R5 counted in the 1-st buffer

   for(int i=0; i<limit; i++)
   {
      RSIBuffer[i]=(iRSI(NULL,0,RSI,RSIprice,i))/100;
      StochBuffer[i]=iStochastic(NULL,0,StochK,StochD,StochSl,StochMAmode,StochPriceField,MODE_MAIN,i)/100;
      SPBuffer[i]=(RSIBuffer[i]+StochBuffer[i])/2;
      TmpDiverBuff[i]=(StochBuffer[i]-RSIBuffer[i]);
      
    }  
      
//---- signal line counted in the 2-nd buffer
   for(i=0; i<limit; i++)
    {  
      FastMABuffer[i]=iMAOnArray(SPBuffer,Bars,SPFastMA,0,SPMAmode,i);
    } 
   for(i=0; i<limit; i++)
    {  
      SlowMABuffer[i]=iMAOnArray(FastMABuffer,Bars,SPSlowMA,0,SPMAmode,i);
      DiverBuffer[i]= iMAOnArray(TmpDiverBuff,Bars,SPSigMA, 0,SPMAmode,i);
    }     
    
//---- done
   return(0);
  }
//+------------------------------------------------------------------+